
proc Set_V785_Options {} {
    global Options V785_Base

    load_Options

   if {![info exists Options(v785.channels)]} {set Options(v785.channels) 4096}
   if {![info exists Options(v785.offset)]} {set Options(v785.offset) 0}
   if {![info exists Options(v785.shift)]} {set Options(v785.shift) 0}
   if {![info exists Options(v785_GroupBase)]} {set Options(v785_GroupBase) $V785_Base}
   set V785_Base   $Options(v785_GroupBase)

    update_Options
}

proc Dump_Raw_VME_Data_V785 {} {

   set data ""

   set maxmodule [inform vmecontrol inquire v785count]
   if {[string length $maxmodule] > 2} {set maxmodule 0}
   for {set i 1} {$i <= $maxmodule} {incr i} {
      append data "V785#$i\n"
      execute-command 19 "Getting Raw Data for V785#$i" "1 $i" 2
      append data [read-register EXEC.Response]
      append data "\n"
   }
   return $data
}

proc define_V785_config {} {
   global VMEserver
    global V785_Base

   set maxmodule [inform vmecontrol inquire v785count]
   if {[string length $maxmodule] > 2} {set maxmodule 0}
   if {$maxmodule > 0} then {DefineConfig "785 0 [format "0x%x" $V785_Base]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {eg "(register :name '/$VMEserver/v785#$i.Output_Buffer'  ?object)" } m]
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to locate register v785#$i.Output_Buffer"
          clear-footer
          error $m
      }
      DefineConfig "785 $i [string range [first $m] 2 end]"
   }
}

proc create_V785_spectra {} {
    global SpectrumServer V785_Base
    global Options

   set maxmodule [inform vmecontrol inquire v785count]
   if {[string length $maxmodule] > 2} {set maxmodule 0}
   set maxadc 32

   for {set i 1} {$i <= $maxmodule} {incr i} {

    set-footer "creating spectra for module v785#$i"

    for {set j 0} {$j < $maxadc} {incr j} {

      set spectrumname [SpectrumName v785#$i.adc$j]
      set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $Options(v785.channels) :name '$spectrumname' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
      if {$z!=0 && $m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum  v785#$i.adc$j"
          clear-footer
          error $m
      } else {
          set group [expr $V785_Base - 1 + $i]
          map_spectrum  "$spectrumname $group $j $Options(v785.offset) $Options(v785.shift)"
      }
    }
   }
}
